
//	Copyright 2010 PaletteSoft LLC

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	006 2010.10.04
//	EPIC24FJ64GA002 p SHT-11 xZT[Rg[̒ǉ by A.Ohta
// ---------------------------------------------------------------------------
//	005 2010.10.02
//	EPIC24FJ64GA002 ɑΉ̈וύX@by A.Ohta
// ---------------------------------------------------------------------------
//	004 2010.08.18
//	EI/O_̏C@by A.Ohta
// ---------------------------------------------------------------------------
//	003 2010.08.07
//	ESHT-11 C^[tF[XI[vhCɑΉ@by A.Ohta
// ---------------------------------------------------------------------------
//	002 2010.07.30
//	EUSARTɂRS232CʐMɕύXB@by A.Ohta
// ---------------------------------------------------------------------------
//	001 2010.05.16
//	EVK쐬@PIC 16F886 3.3V 쓮pɕύX@by@A.Ohta
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************
// ***************************************************************************

#include	"p24FJ64GA002.h"

#include	<uart.h>

	//	***** 錾 *****

#include	"_AtrDef24f.h"												//	萔Af[^^̐錾

	//	*****  *****

#include	"version.h"													//	o[Wԍ̒`

#include	"device.h"													//	foCX

#include	"nokiaGlcdlib.h"											//  LCD

#include	"sht.h"														//  sht

// ***************************************************************************
// *	zdl																 *
// ***************************************************************************
/*
	PIC24F UART ]TvvO	PIC24FJ64GA002  CLOCK:8MHz Vdd = 3.3V

	RA0:DRDY 				PIC <- SCP1000		input "1"
	RA1:MISO				PIC <- SCP1000		input "1"
	RA2:CSB					PIC -> SCP1000		output"0"
	RA3:SCK					PIC -> SCP1000		output"0"

	RA4:MOSI				PIC -> SCP1000		output"0"

	RB0:(gp)									input "1"
	RB1:DIP_SW1				PIC <- DIP_SW1		input "1"
	RB2:DIP_SW2				PIC <- DIP_SW2		input "1"
	RB3:gp									input "1"

	PB4:UART1 TX to RP4		PIC -> PC			output"0"(RP4)
	RB5:(gp)									input "1"
	RB6:(gp)									input "1"
	RB7:(gp)									input "1"

	RB8:(gp)									input "1"
	RB9:DATA				PIC <->	SHT			output,input "0,1"(o) 	Open Drein "1"
	RB10:SCK				PIC ->	SHT			output"0"					Open Drein "1"
	RB11:(INV)RES			PIC -> GLCD			output"0"

	RB12:D/C				PIC -> GLCD			output"0"
	RB13:SLCK				PIC -> GLCD			output"0"
	RB14:SDIN				PIC -> GLCD			output"0"
	RB15:(INV)SCE			PIC -> GLCD			output"0"

*/


// ***************************************************************************
// *																	 *
// ***************************************************************************

/// RtBM[V rbg̐ݒ
	_CONFIG1(
			JTAGEN_OFF												// JTAG̎gpF
		&	GCP_OFF													// R[hveNgFȂ
		&	GWRP_OFF												// ݃veNgFȂ
		&	BKBUG_OFF												// obNOEhfobOF
		&	COE_OFF													// NbvIG~[VF
		&	ICS_PGx1												// EMUC/EMUDPCG1/PGD1Ƌp
		&	FWDTEN_OFF												// WDTF
	) 

/// Fosc = FRC (8MHz)
	_CONFIG2(
			IESO_OFF												// QxX^[gAbvF
		&	FNOSC_FRC												// ȖIFFRCI
		&	FCKSM_CSDCMD											// NbN؂ւENbNj^Fɖ
		&	OSCIOFNC_ON												// OSCOs@\FOSCO܂Fosc/2̏o͂ȂARA3 ditital I/O
		&	IOL1WAY_OFF												// RPWX^veNgFveNgȂ
		&	I2C1SEL_PRI												// I2C1̃sIFsgp
		&	POSCMOD_NONE											// 唭UFgpȂ
)

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************

//								  5432109876543210
#define	INIT_PORTA_DIR			0b1111111111100011 					//	|[gAo͕ gp|[g͓͐ݒƂBid팸ׁ̈j
#define	INIT_PORTB_DIR			0b0000001111101110 					//	|[gBo͕ gp|[g͓͐ݒƂBid팸ׁ̈j

//                         		  5432109876543210
unsigned int U1MODEvalue =		0b1000100000001000;					// UART1ݒ
unsigned int U1STAvalue =		0b0000010000000000;					// UART1ݒ
unsigned int Baud = 51;												//@mode 19200bps at 4MHz 8bit nonparity stopbit 1 nonflowcnt.

// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	e[u																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************
// ***************************************************************************

#define	SHT_DATA_DIR	(1 << 9)									//  PB9

// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************
// ***************************************************************************

	//	***** M *****

void	DevSigPutMOSI_H(void);
void	DevSigPutMOSI_L(void);
void	DevSigPutSCK_H(void);
void	DevSigPutSCK_L(void);

UB		DevSigGetMISO(void);

	//	***** ʐM *****

void	DevComBrtStart(void);
void	DevComBrtStop(void);
void	DevComSendBit(UB Data);
void	DevComWaitSend(void);

// ***************************************************************************
// ***************************************************************************
// *	{																 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		{
//
//	
//	
void	DevStd______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ohb}CRݒ肵܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

	//	***** o̓|[g *****

	//I/Oݒ
	CLKDIV = 0;										// set 1:1	
	AD1PCFG = 0xFFFF;   							// AD@Set to all Digital I/O ports.

	TRISA = INIT_PORTA_DIR;
	TRISB = INIT_PORTB_DIR;
	LATBbits.LATB9 = 0;

	ODCB = 0x0000;									// RB9,RB10 set to Open Drein  ********************************

	RPOR2bits.RP4R = 3;								// UART1 TX to RP4(PB4)

	OpenUART1( U1MODEvalue, U1STAvalue, Baud);		// INIT for UART1 with 19200 8bit nonparity nonflowcnt.
}

//	
//	
//
// 		M
//
//	
//	
void	DevSig______(void) {}											//	op֐

//============================================================================
//	CZTւ̏o
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	CZTւ̐M𐧌䂵܂B
//============================================================================
void	DevSigPutMOSI_H(void)	{	LATAbits.LATA4 = 1;	}
void	DevSigPutMOSI_L(void)	{	LATAbits.LATA4 = 0;	}

void	DevSigPutSCK_H(void)	{	LATAbits.LATA3  = 1;	}
void	DevSigPutSCK_L(void)	{	LATAbits.LATA3  = 0;	}

void	DevSigPutCSB_H(void)	{	LATAbits.LATA2  = 1;	}
void	DevSigPutCSB_L(void)	{	LATAbits.LATA2  = 0;	}

//============================================================================
//	CZT̓
//----------------------------------------------------------------------------
//	́F	
//	óF	M̏ԁiOFkAOFgj
//----------------------------------------------------------------------------
//	lF	CZT̐M͂܂B
//============================================================================
UB		DevSigGetMISO(void)		{	return(PORTAbits.RA1);	}

//============================================================================
//	xZTւ̓o
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lFxZTւ̐M𐧌䂵܂B
//============================================================================

void	DevSigPutShtSCK_H(void)	{	LATBbits.LATB10 = 1;	}
void	DevSigPutShtSCK_L(void)	{	LATBbits.LATB10 = 0;	}

void	DevSigPutShtDATA_H(void)	{	TRISB |= SHT_DATA_DIR;		}
void	DevSigPutShtDATA_L(void)	{	TRISB &= ~(SHT_DATA_DIR);	}


//	
//	
//
// 		ʐM
//
//	
//	


//	
//	
//
// 		Ԑ
//
//	
//	
void	DevTim______(void) {}											//	op֐

//============================================================================
//	usecPʃfBC֐
//----------------------------------------------------------------------------
//	́F	PUrbg
//	óF	
//----------------------------------------------------------------------------
//	lF	CLOCK:MIPS of this PIC
//============================================================================
void delay_us(UINT usec)
{
	usec = (UINT)(CLOCK*usec)/ 10;
	while(usec)	{
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");
		asm("NOP");					
		usec--;
	}
}

//============================================================================
//	msecPʃfBC֐
//----------------------------------------------------------------------------
//	́F	PUrbg
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================
void delay_ms(UINT msec){
	UINT i;
	for(i=0; i< msec; i++)
		delay_us(1000);
}

//	
//	
//
// 		roh
//
//	
//	
void	DevSpi______(void) {}											//	op֐

	//	***** M *****

#define	mSpiClk_L()				DevSigPutSCK_L()						//	NbNMk
#define	mSpiClk_H()				DevSigPutSCK_H()						//	NbNMg

#define	mSpiOut_L()				DevSigPutMOSI_L()						//	o̓f[^k
#define	mSpiOut_H()				DevSigPutMOSI_H()						//	o̓f[^g

#define	mSpiIn()				DevSigGetMISO()							//	̓f[^iOAOŔfj

	//	***** Ԑ *****

#define	mSpiWaitTDS()								 					//	f[^ZbgAbvԁi̎ԑҋ@ANbNMgɐ؂ւj

#define	mSpiWaitTCH()													//	NbNMgێ
#define	mSpiWaitTCL()													//	NbNMkێ

//============================================================================
//	Mݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	rohʐMŎgpo͐Mݒ肵܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
void	DevSpiInit(void)
{
	mSpiClk_L();														//	NbNMk
	mSpiOut_L();														//	o̓f[^Mk
}

//============================================================================
//	CӃrbg̑M
//----------------------------------------------------------------------------
//	́F	Mf[^
//	óF	
//----------------------------------------------------------------------------
//	lF	Mf[^̂lra珇ԂɃrbg̑Ms܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
void	DevSpiPutData(UB Data)
{
	UB		Number = 8;													//	Mrbg

	//	***** M *****

	while (Number --) {													//	MrbgJԂ

		//	***** f[^o *****

		if (Data & (UB)0x80) {											//	lraPH
			mSpiOut_H();												//	o̓f[^g
		}
		else {															//	lraO
			mSpiOut_L();												//	o̓f[^k
		}
		mSpiWaitTDS();													//	ҋ@Ff[^ZbgAbv

		//	***** NbN *****

		mSpiClk_H();													//	NbNMg
		mSpiWaitTCH();													//	ҋ@FNbNg
		mSpiClk_L();													//	NbNMk
		mSpiWaitTCH();													//	ҋ@FNbNg

		//	***** ̃rbg *****

		Data <<= 1;														//	PrbgVtg
	}
}

//============================================================================
//	Wrbg̎M
//----------------------------------------------------------------------------
//	́F	
//	óF	Mf[^
//----------------------------------------------------------------------------
//	lF	Wrbg̃f[^lraMĕԂ܂B
//			ΏۃfoCXIbr͏ʊ֐Ő䂵ĂB
//============================================================================
UB		DevSpiGetData(void)
{
	UB		Number = 8;													//	Mrbg
	UB		Data = 0;													//	Mf[^

	//	***** M *****

	while (Number --) {													//	MrbgJԂ

		//	***** ̃rbg *****

		Data <<= 1;														//	PrbgVtg

		//	***** f[^ *****

		if (mSpiIn()) {													//	̓f[^͂gH
			Data |= (UB)0x01;											//	̍
		}
//*		mSpiWaitTDS();													//	ҋ@Ff[^ZbgAbv	{sv

		//	***** NbN *****

		mSpiClk_H();													//	NbNMg
		mSpiWaitTCH();													//	ҋ@FNbNg

		mSpiClk_L();													//	NbNMk
		mSpiWaitTCL();													//	ҋ@FNbNk
	}

	//	***** ܂ *****

	return(Data);														//	Mf[^Ԃ܂
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

