
//	Copyright 2010 PaletteSoft LLC

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^										@@@@@@					 =
// ===========================================================================
//	013 2010.10.04
//	EPIC24FJ64GA002 p SHT-11 xZT[Rg[̒ǉ by A.Ohta
// ---------------------------------------------------------------------------
//	012 2010.10.02
//	EPIC24FJ64GA002 ɑΉ̈וύXAxZT[̍폜@by A.Ohta
// ---------------------------------------------------------------------------
//	011 2010.08.24
//	EC\Vtg\ɂi\[`̊Sj@by A.Ohta
// ---------------------------------------------------------------------------
//	010 2010.08.18
//	EI/O_̏C@by A.Ohta
// ---------------------------------------------------------------------------
//	009 2010.08.10
//	Evbg[`̒ǉ@by A.Ohta
// ---------------------------------------------------------------------------
//	008 2010.08.08
//	ESHT-11 C^[tF[XI[vhCɑΉɔ
//   xf[^RS232CʐM̕ύX@by A.Ohta
// ---------------------------------------------------------------------------
//	007 2010.08.07
//	ESHT-11 C^[tF[XI[vhCɑΉ@by A.Ohta
// ---------------------------------------------------------------------------
//	006 2010.07.31
//	EvO̖ʂȂAvOTCYׁ@by A.Ohta
// ---------------------------------------------------------------------------
//	005 2010.07.30
//	EUSARTW[̎gpsׁ@by A.Ohta
// ---------------------------------------------------------------------------
//	004 2010.07.26
//	Ex\ʐM[`̒ǉɂC@by A.Ohta
// ---------------------------------------------------------------------------
//	003 2010.07.26
//	Ex\[`̒ǉɂC@by A.Ohta
// ---------------------------------------------------------------------------
//	002 2010.07.12
//	ECC\[`̏C@by A.Ohta
// ---------------------------------------------------------------------------
//	001 2010.06.28
//	EVK쐬 PaletteSoft LLC@̃vOXg̈ꕔ@OtBbNLCD
//   (mLA5110LCDjbgjɕ\o悤ɈꕔύXĐ@by A.Ohta
// ===========================================================================


#define	SYSTEM_NAME				"SCP1000-D01 SAMPLE PROGRAM"			//	VXe
#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *	CN[ht@C														 *
// ***************************************************************************

	//	*****  *****

#include	"p24FJ64GA002.h"											//  PIC^

#include	<uart.h>

	//	***** 錾 *****

#include	"_AtrDef24f.h"												//	萔Af[^^̐錾

	//	*****  *****

#include	"version.h"													//	o[Wԍ̒`

#include	"device.h"													//	foCX

#include	"press.h"													//	̓ZT

#include	"nokiaGlcdlib.h"											//  LCD

#include	"sht.h"														//  sht

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

// bZ[W̒` //

// ***************************************************************************
// *	O[oϐ															 *
// ***************************************************************************

UB		vMngDispBuffer[16];												//	\pobt@

sPres	vMngMeasData;													//	茋
UW		vMngPres;														//	Cf[^
UH		vMngTemp;														//	xf[^
UH		vMngRhum;														//	xf[^		

UH MemPres[48];															//  \pCf[^̋L̈

unsigned char nummsg0[] = "100.0";										//  lϊpobt@100%\p
unsigned char nummsg1[] = "50";											//  lϊpobt@1
unsigned char nummsg2[] = "0";											//  lϊpobt@2
unsigned char nummsg3[] = "0";											//  lϊpobt@2

UINT gint;
UINT gcount;
UINT gintT;
UINT gX;

UINT LCD_MAX_PRES;
UINT LCD_MIN_PRES;

UH	aDValHR;

// ***************************************************************************
// *	e[u																 *
// ***************************************************************************

	//	***** VXe *****

const	UB		tSystemName[] = SYSTEM_NAME;							//	VXe̕
const	UB		tCopyright[] = COPYRIGHT;								//	쌠\
const	UB		tVersion[] = {											//	o[Wԍ
					VER1 | '0', VER2 | '0', '.', VER3 | '0', VER4 | '0', CODE_NUL
};

	//	*****  *****

const	UB		tCrLf[] = "\r\n";										//	bqCke

const	UB		tCnvHexAscL[16] = {										//	Srbg̐lPUȋ啶R[hɕϊ
	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
	'8',	'9',	'A',	'B',	'C',	'D',	'E',	'F',
};

// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************

	//	***** }lWg *****

void	MngSensorInit(void);

	//	***** \ *****

void	MngDspHello(void);

void	MngDspValue(void);
void	MngDspPress(UW Pres);
void	MngDspTemp(UH Temp);
void	MngDspRhum(UH Rhum);
void	MngplotPres(UW);
void	MngplotTemp(UH);
void	MngplotRhum(UH);

	//	***** Cu *****

UB*		LibHexAscUB(UB *Buffer, UB Value);

UH		LibDivUH(UH Value1, UH Value2);
UW		LibMulUH(UH Value1, UH Value2);

void	LibItoA4(UB *Buffer, UH Value);

void itostring(char digit, unsigned int data, char *buffer);

// ***************************************************************************
// *	{																 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
int	main(void)
{
	//	***** ͂߂ *****
	int	i;

	DevInit();															//	foCXݒ
	DevSpiInit();														//	roh䏉ݒ
	SHTInit();															//  SHTݒ
	LCD_init();															// @LCD

	LCD_locate(0,0);
	LCD_clear(LCD_WIDTH * LCD_BANKS);

	print_unithps();
	print_percent();
	print_unitdeg();
	print_Yaxis();
  
	for (i = 0;i<48;i++) {												//  MemPres[]ōlŃNA
		MemPres[i] = 2000;
	}

	//	***** ^pJn *****

	MngDspHello();														//	uN\
	MngSensorInit();													//	ZTݒ
	PrsSeqMeas();														//	Jniʂ͖܂cÎ͂j

	//	*****  *****

	while (1) {															//	[vł
		putsUART1((unsigned int *)"SCP,");											//	\

		if (PrsSeqGetData(&vMngMeasData)) {								//	łH	ł܂Ŗ񂵂Ă܂

			//	***** f[^ҏW *****									//				̃f[^Zbg܂łɏĂiTOOj

			MngDspValue();												//	茋ʂPUiŕ\

			vMngPres = PrsCalGetPres(&vMngMeasData);					//	Cf[^擾
			vMngTemp = PrsCalGetTemp(&vMngMeasData);					//	xf[^擾
			vMngRhum = ShtCalGetRhum();									//	xf[^擾

			MngDspPress(vMngPres);										//	Cf[^̕ʕ\
			MngDspTemp(vMngTemp);										//	xf[^̕ʕ\
			MngDspRhum(vMngRhum);										//  xf[^̕ʕ\

			if (gcount>gintT){											//  gintTC^[oPlot
				MngplotPres(vMngPres);									//  CplotB
				MngplotTemp(vMngTemp);									//  CplotB
				MngplotRhum(vMngRhum);									//  xplotB

				if (gX<48){												//  vbgʒu+PBgX:0`47
					gX++;
				}
				else{													//  vbgʒuE[܂œBꍇ́A[㏑B
					gX = 0;
				}
				gcount = 0;
			}
			else{
					gcount++;
			}
		}
		else {															//	莸s

			//	***** 莸s *****

			putsUART1((unsigned int *)" RTERR ");						//	A^CG[\
		}


	}
}

//============================================================================
//	ZTݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ZT̋Nҋ@܂BNɈُ킪oꂽꍇ̓ZT
//			Zbgs܂BN܂ł̍ƂJԂ܂B
//============================================================================
void	MngSensorInit(void)
{
	UB		Result;														//	

	//	***** ݒ菄 *****

	while (1) {															//	N܂ŌJԂ܂B

		//	***** ݒ *****

		putsUART1((unsigned int *)"SENSOR INIT ");						//	\

		Result = PrsSeqInit();											//	ZT̏ݒ
		putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, Result));	//	ʂPUiɕϊĕ\
		putsUART1((unsigned int *)" ");

		//	***** ݒ茋ʐff *****

		if ((Result & PRS_INIT_RESULT_MASK) != PRS_INIT_RESULT_OK) {	//	ݒ莸sH
			putsUART1((unsigned int *)"NG \r\n");						//	\
			delay_ms(250);												//	QTOҋ@
			delay_ms(250);												//	QTOҋ@
		}
		else {															//	ݒ萬
			break;														//	Eo
		}
	}

	//	***** ݒI *****

	Result = PrsSeqGetRevid();											//	rWԍ擾

	putsUART1((unsigned int *)"OK, ASIC:");								//	\
	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, Result));		//	ʂPUiɕϊĕ\
	putsUART1((unsigned int *)tCrLf);									//	bqAke
}

//	
//	
//
// 		\
//
//	
//	
void	MngDsp______(void) {}											//	op֐

//============================================================================
//	uN\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uNƂ𒲕VAʐMŒʒm܂B
//============================================================================
void	MngDspHello(void)
{
	//	***** o *****

	putsUART1((unsigned int *)tCrLf);									//	bqAke
	putsUART1((unsigned int *)tCrLf);									//	bqAke

	//	***** ^Cg *****

	putsUART1((unsigned int *)tSystemName);								//	VXe

	putsUART1((unsigned int *)"  Ver");									//	o
	putsUART1((unsigned int *)tVersion);								//	o[Wԍ
	putsUART1((unsigned int *)tCrLf);									//	bqAke

	putsUART1((unsigned int *)tCopyright);								//	쐬
	putsUART1((unsigned int *)tCrLf);									//	bqAke

	//	***** ܂ *****

	putsUART1((unsigned int *)tCrLf);									//	bqAke
}

//============================================================================
//	茋ʂPUiŕ\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ς݂̃f[^PUiŕ\܂B
//
//			ss,tttt,mm,llll,ss,
//============================================================================
void	MngDspValue(void)
{
	//	***** Xe[^XP *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Status1));
	putsUART1((unsigned int *)",");

	//	***** xf[^ *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Temp     >> 8));
	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Temp         ));
	putsUART1((unsigned int *)",");

	//	***** Cf[^ilraj *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.PresMsb));
	putsUART1((unsigned int *)",");

	//	***** Cf[^ikraj *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.PresLsb >> 8));
	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.PresLsb     ));
	putsUART1((unsigned int *)",");

	//	***** Xe[^XQ *****

	putsUART1((unsigned int *)LibHexAscUB(vMngDispBuffer, vMngMeasData.Status2));
	putsUART1((unsigned int *)",");

	//	***** ܂ *****

	putsUART1((unsigned int *)" ");
}

//============================================================================
//	Cf[^̕ʕ\							ӁF͈̓`FbN͎蔲
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF	Cf[^𕨗ʕϊĕ\܂B
//
//			f[^\F0.25Pa/bit
//			f[^͈́F30000.00 - 120000.00Pa		QlF100Pa = 1hPa
//			\`@FP:XXXXhPa,
//============================================================================
void	MngDspPress(UW Pres)
{
	UH		Value;														//	Ɨpϐ

/*
	Cf[^pXJϊ
		Pa = Pres * 0.25 = Pres / 4
	ƂȂ܂BZ͉ł܂_ȉ͐؂̂ĂɂȂ܂B
	āApXJwNgpXJɕϊꍇ́A
		100Pa = 1hPa
	A_ȉ̐؂̂ĂƁA
		hPa = (Pres / 4) / 100 = Pres / (4 * 100) = Pres / 400
	ƂȂ܂B
*/
	Value = (UH)(Pres / 400L);											//	ʏ300 `1200͈͓̔̂͂

	LibItoA4(vMngDispBuffer, Value);									//	l𕶎ɕϊisSj

	if (vMngDispBuffer[0] == '0') {	vMngDispBuffer[0] = ' ';	}		//	[TvXïʂjj

	//	***** pXJ\ *****

	putsUART1((unsigned int *)"P:");									//	
	putsUART1((unsigned int *)vMngDispBuffer);							//	Zʕ\
	putsUART1((unsigned int *)"hPa,");									//	P

	print_press((int)Value);
}

//============================================================================
//	xf[^̕ʕ\							ӁF͈̓`FbN͎蔲
//----------------------------------------------------------------------------
//	́F	xf[^iPSrbg\A}CiXx͂Q̕␔\j
//	óF	
//----------------------------------------------------------------------------
//	lF	xf[^𕨗ʕϊĕ\܂B
//
//			f[^\F0.05c/bit
//			\`@FT:-XX.Xc,
//============================================================================
void	MngDspTemp(UH Temp)
{
/*
	xf[^
		c = Temp * 0.05 = Temp / 20
	ƂȂ܂BZ͉ł܂_ȉ͐؂̂ĂɂȂ܂B
	ɏ_ȉPʂ܂ŋ߂̂ł΁A
		c * 10 = (Temp * 10) / 20 = Temp / 2
	ƂȂ܂B
	Oq̋CƓlALȉ͐؂̂Ăs܂B
	Ȃxɂ̓}CiXl݂܂A؂̂ă[͐ΒlōsĂ܂B
*/

	if (Temp & (UH)BIT15) {												//	}CiXwH
		vMngDispBuffer[0] = '-';										//	vX}[N
		Temp = (~Temp) + 1;												//	ΒlZo
	}
	else {																//	vXw
		vMngDispBuffer[0] = '+';										//	vX}[N
	}

	LibItoA4(&vMngDispBuffer[1], Temp >> 1);							//	l𕶎ɕϊisSj
																		//	ZT\-30c`+85cȂ̂ŁAΒl0`850͈͓̔̂͂
//	12345		12345
//	 XXX*	@XX.X*

	vMngDispBuffer[1] = vMngDispBuffer[2];								//	PÖʂOɈړ
	vMngDispBuffer[2] = vMngDispBuffer[3];								//	P̈ʂOɈړ
	vMngDispBuffer[3] = '.';											//	_

	if (vMngDispBuffer[1] == '0') {	vMngDispBuffer[1] = ' ';	}		//	[TvXi\̈ʂj

	//	***** x\ *****

	putsUART1((unsigned int *)"T:");									//	
	putsUART1((unsigned int *)vMngDispBuffer);							//	Zʕ\
	putsUART1((unsigned int *)"c,");									//	P

	print_temp(Temp/2, (Temp & (UH)BIT15));
}

//============================================================================
//	xf[^̕ʕ\							
//----------------------------------------------------------------------------
//	́Fxf[^i@j
//	óF	
//----------------------------------------------------------------------------
//	lFxf[^𕨗ʕϊĕ\܂B
//
//			f[^\F?/bit
//			\`@FRH:XX.X%,
//============================================================================
void	MngDspRhum(UH Rhum)
{
	int vRhum;
	aDValHR = Rhum;
	vRhum = CalcHR10();

	print_RH(vRhum);

			//	***** xM *****
	putsUART1((unsigned int *)"RH:");									//	
	if(vRhum >= 1000 ){
		putsUART1((unsigned int *)"100.0%,");							//	100.0%\
	}
	else if(vRhum < 100 ){
		itostring(1,vRhum/10, (char *)nummsg2);
		itostring(1,vRhum%10, (char *)nummsg3);

		putsUART1((unsigned int *)&nummsg2);							//	Zʕ\
		putsUART1((unsigned int *)".");									//	Pʏ_
		putsUART1((unsigned int *)&nummsg3);							//	Zʕ\
		putsUART1((unsigned int *)"%,");								//	P
	}
	else {

		itostring(2,vRhum/10, (char *)nummsg1);
		itostring(1,vRhum%10, (char *)nummsg2);

		putsUART1((unsigned int *)&nummsg1);							//	Zʕ\
		putsUART1((unsigned int *)".");									//	Pʏ_
		putsUART1((unsigned int *)&nummsg2);							//	Zʕ\
		putsUART1((unsigned int *)"%");									//	P
	}

	putsUART1((unsigned int *)tCrLf);									//	bqAke
}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotPres(UW Pres)
{
	int i;
	UH	Value;
	Value = (UH)(Pres / 400L);											//	ʏ300 `1200͈͓̔̂͂
	MemPres[gX] = Value;												//  Cf[^̗cB
 
	if (Value > LCD_MAX_PRES ) {										//  \̍ől𒴂H
		LCD_MAX_PRES = Value;											//  ݂̒lőƂ臒lɕύXB
		LCD_MIN_PRES = LCD_MAX_PRES - 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Presgraph(i, MemPres[i] );							//  C̗V臒lŃvbg
		}
	}
	else if (Value < LCD_MIN_PRES ) {									//  \̍ŏlH
		LCD_MIN_PRES = Value;											//  ݂̒lŏƂ臒lɕύXB
		LCD_MAX_PRES = LCD_MIN_PRES + 15 ;
		for (i = 0; i < 48 ; i++ ) {
			print_Presgraph(i, MemPres[i] );							//  C̗V臒lŃvbg
		}
	}
	print_Presgraph(gX, Value);											//  ݂̋Cvbg
}

//============================================================================
//	Cf[^Plot							
//----------------------------------------------------------------------------
//	́F	Cf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotTemp(UH Temp)
{
	if (Temp & (UH)BIT15) {												//	}CiXwH
		Temp = (~Temp) + 1;												//	ΒlZo
	}
	print_Tempgraph(gX, (int)Temp/20);									//  Cvbg																	
}

//============================================================================
//	xf[^Plot							
//----------------------------------------------------------------------------
//	́F	xf[^
//	óF	
//----------------------------------------------------------------------------
//	lF
//
//============================================================================
void	MngplotRhum(UH Rhum)
{
	int vRhum;

	aDValHR = Rhum;
	vRhum = CalcHR10();													//  xf[^𕨗ʂɕϊB

	print_Rhumgraph(gX, vRhum/10);										//  xvbg																	
}

//	
//	
//
// 		Cu
//
//	
//	
void	Lib______(void){}												//	op֐

//============================================================================
//	PoCglPUiɕϊ
//----------------------------------------------------------------------------
//	́F	i[obt@iQ{PjAlA
//	óF	i[obt@
//----------------------------------------------------------------------------
//	lF	PoCglQ̂PUiɕϊ܂B
//============================================================================
UB*	LibHexAscUB(UB *Buffer, UB Value)
{
	Buffer[0] = tCnvHexAscL[Value >> 4];								//	ʂSrbgϊ
	Buffer[1] = tCnvHexAscL[Value & 0x0f];								//	ʂSrbgϊ
	Buffer[2] = CODE_NUL;												//	I[R[hZbg

	return(Buffer);														//	obt@AhXԂ܂
}

//============================================================================
//	QoCgQoCgQoCg
//----------------------------------------------------------------------------
//	́F	񏜐A
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCg̏Zs܂B
//============================================================================
UH		LibDivUH(UH Value1, UH Value2)
{
	return(Value1 / Value2);											//	QoCgZʂԂ܂
}


//============================================================================
//	QoCg~QoCgSoCg
//----------------------------------------------------------------------------
//	́F	搔A搔
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCg̏Zs܂B
//============================================================================
UW		LibMulUH(UH Value1, UH Value2)
{
	return((UW)Value1 * (UW)Value2);									//	QoCg̏ZʂԂ܂
}

//============================================================================
//	͋ẐSPOiϊ
//----------------------------------------------------------------------------
//	́F	i[AhXAl
//	óF	
//----------------------------------------------------------------------------
//	lF	QoCgl𕶎ɕϊ܂BL͂S܂łłB
//============================================================================
void	LibItoA4(UB *Buffer, UH Value)
{
	UB		Digit;														//	P̐l

	Digit = (UB)LibDivUH(Value,      1000);								//	@POOÖʕҏW
	Value -= (UH)LibMulUH((UH)Digit, 1000);
	Buffer[0] = Digit + '0';

	Digit = (UB)LibDivUH(Value,       100);								//	@@POÖʕҏW
	Value -= (UH)LibMulUH((UH)Digit,  100);
	Buffer[1] = Digit + '0';

	Digit = (UB)LibDivUH(Value,        10);								//	@@@PÖʕҏW
	Value -= (UH)LibMulUH((UH)Digit,   10);
	Buffer[2] = Digit + '0';

	Buffer[3] = (UB)Value + '0';										//	@@@@P̈ʕҏW

	Buffer[4] = CODE_NUL;												//	I[Zbg
}

/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;
	buffer += digit;													// Ō̐ʒu
	for(i=digit; i>0; i--) {											// ϊ͉ʂʂ
		buffer--;														// |C^[P
		*buffer = (data % 10) + '0';									// ASCII
		data = data / 10;												// ̌
	}
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

